# NaiveTicket

The second Objects lab,from the BlueJ book's second chapter.

Look for the [Chapter 2 file](./doc/BlueJ-objects-first-ch2.pdf) you need in the [doc](./doc) folder. There is 35 pages of reading and exercises in the chapter.

Work through all these exercises. You edit this file with your answers for these exercises.

* Exercise 2.1 Create a TicketMachine object on the object bench and take a look
at its methods. You should see the following: getBalance, getPrice, insertMoney,
and printTicket. Try out the getPrice method. You should see a return value containing
the price of the tickets that was set when this object was created. Use the
insertMoney method to simulate inserting an amount of money into the machine and
then use getBalance to check that the machine has a record of the amount inserted.
You can insert several separate amounts of money into the machine, just like you might
insert multiple coins or notes into a real machine. Try inserting the exact amount
required for a ticket. As this is a simple machine, a ticket will not be issued automatically,
so once you have inserted enough money, call the printTicket method. A
facsimile ticket should be printed in the BlueJ terminal window.
* Exercise 2.2 What value is returned if you check the machine’s balance after it
has printed a ticket?
  - 0 is returned as the balance

* Exercise 2.3 Experiment with inserting different amounts of money before printing
tickets. Do you notice anything strange about the machine’s behavior? What happens
if you insert too much money into the machine – do you receive any refund? What
happens if you do not insert enough and then try to print a ticket?
  - no refund when I insert too much.
  - ticket still prints when you insert too little.

* Exercise 2.4 Try to obtain a good understanding of a ticket machine’s behavior by
interacting with it on the object bench before we start looking at how the
TicketMachine class is implemented in the next section.
* Exercise 2.5 Create another ticket machine for tickets of a different price. Buy a
ticket from that machine. Does the printed ticket look different?
  - it acts exactly the same, except the price has changed, thus printing the new price when I print ticket.

* Exercise 2.6 Write out what you think the outer wrappers of the Student and
LabClass classes might look like – do not worry about the inner part.
  - public class Student
  - public class LabClass

* Exercise 2.7 Does it matter whether we write
`public class TicketMachine`
or
`class public TicketMachine`
in the outer wrapper of a class? Edit the source of the TicketMachine class to
make the change and then close the editor window. Do you notice a change in the
class diagram?
  - yes, it does matter. I received an error when compiling.

What error message do you get when you now press the Compile button? Do you think
this message clearly explains what is wrong?
  - "<identifier> expected"
  - the error doesn't specifically say, "you switched it around and you need to switch it back", but it's letting me know that it's expecting something that's not there - because i put it where it shouldn't be

* Exercise 2.8 Check whether or not it is possible to leave out the word public
from the outer wrapper of the TicketMachine class.
  - yes, it is possible

* Exercise 2.9 From your earlier experimentation with the ticket machine objects
within BlueJ you can probably remember the names of some of the methods –
printTicket, for instance. Look at the class definition in Code 2.1 and use this
knowledge, along with the additional information about ordering we have given you,
to try to make a list of the names of the fields, constructors, and methods in the
TicketMachine class. Hint: There is only one constructor in the class.
  - Fields: price, balance, total
  - Constructors: TicketMachine(ticketCost)
  - Methods: getPrice(), getBalance(), insertMoney(amount), printTicket()

Exercise 2.10 Do you notice any features of the constructor that make it significantly
different from the other methods of the class?
  - constructor carries the same name as the class (by definition)
  - constructor is the only method to initialize variables

* Exercise 2.11 What do you think is the type of each of the following fields?
```
private int count;
  - integer
private Student representative;
  - object of class Student, titled "representative"
private Server host;
  - object of class Server, titled "host"
```
* Exercise 2.12 What are the names of the following fields?
```
private boolean alive;
private Person tutor;
private Game game;
```
  - "alive"
  - "tutor"
  - "game"

* Exercise 2.13 In the following field declaration from the TicketMachine class
```
private int price;
```
does it matter which order the three words appear in? Edit the TicketMachine class to
try different orderings. After each change, close the editor. Does the appearance of the
class diagram after each change give you a clue as to whether or not other orderings are
possible? Check by pressing the Compile button to see if there is an error message.
Make sure that you reinstate the original version after your experiments!
  - yes, it matters. the access modifier must come before the type, which comes before the field name.

* Exercise 2.14 Is it always necessary to have a semicolon at the end of a field declaration?
Once again, experiment via the editor. The rule you will learn here is an
important one, so be sure to remember it.
  - yes. IDE message says " \r;\r expected"

* Exercise 2.15 Write in full the declaration for a field of type int whose name is
status.
* Exercise 2.16 To what class does the following constructor belong?
```
public Student(String name)
```
  - belongs to Student class. By definition, constructors are named after their classes
* Exercise 2.17 How many parameters does the following constructor have and what are their types?
```
public Book(String title, double price)
```
  - two parameters of types String and double, respectively
* Exercise 2.18 Can you guess what types some of the Book class’s fields might be? Can you assume anything about the names of its fields?
  - String: book name, int: number of pages, String/int: serial number, string: author

Work all Exercises from 2.19 to 2.58 that are NOT marked *Challenge exercise*.
- 2.19 Exercise
  - publicPet(String petsName){
    name = petsName;
    }
- 2.20 Exercise
  - what's wrong with the code below is that it declares price <strong> within</strong> the constructor. price will no longer be available for use when the constructor completes its code.
  <pre><code>public TicketMachine(int ticketCost) {
      int price = ticketCost;
      balance = 0;
      total = 0;
   </code></pre>
  }
  - in the case of implementing this constructor within <em>naive-ticket-machine</em>, it appears to be <strong>re</strong>declaring <q>price</q>. Thus, perhaps, a new price variable is created and within the scope of the constructor. While the global price that is called by <em>getPrice()</em> remains 0.
  - 2.21 Exercise
    -one returns balance one returns price;
  - 2.22
    - "How much money has been inserted thus far"
  - 2.23
    - no
  - 2.25
    - "Missing return statement"
  - 2.26
    - getPrice() has return type <em>int</em>, whereas printTicket() has no return type (void).
  - 2.27
    - they have a return type of <em>void</em>
  - 2.29
    - because it doesn't have the same name as the class
  - 2.30
    <pre><code>public void setPrice(int ticketCost){
      price = ticketCost;
    }</code></pre>
  - 2.31
    <pre><code> public void increase(int points){
      score = points;
    }</code></pre>
  - 2.32
    <pre><code> pbulic void discount(int amount){
      price = price - amount;
    }</code></pre>
  - 2.36
    -  <code>System.out.println("# \"" + price + "\" cents.");</code>
  - 2.37
    - <code>System.out.println("# price cents.");</code>
      - the above will print everything within the quotes as is.
    - <code>System.out.println("# " + "price" + " cents.");</code>
      - this <strong>HERE</strong> will print the same as the coded bullet above it.
  - 2.38
    - neither of them, because <em>price</em> is not inserted as a variable, but rather a <strong><em>String</em></strong>
  - 2.39
    - by not having a parameter in the constructor, there is no dialog upon calling the constructor to set the ticket price.
  - 2.4
    - <em>empty()</em> method is a mutator
  
READ upto and INCLUDING section 2.15 of this chapter.
